from merescocore.framework import Observable
import re

class ComposeJELFromMods(Observable):
    def __init__(self, fieldName ):
        Observable.__init__(self)
        self._namespaceMap = {'mods':'http://www.loc.gov/mods/v3'}
        self._fieldName = fieldName

    def add(self, id, partName, lxmlNode):
        classifications = lxmlNode.xpath('//mods:mods/mods:classification', self._namespaceMap)
        pattern = re.compile("^[a-zA-Z]\d{0,2}$")

        for classification in classifications:
            authority = classification.xpath('@authority', self._namespaceMap)
            text = classification.xpath('text()', self._namespaceMap)

            if len(authority) == 1:
                self.logger("authority: " + str (authority[0]))
                if str(authority[0]) == 'info:eu-repo/authority/jel' or \
                   str(authority[0]) == 'info:eu-repo/classification/jel':
                    if len(text) == 1:
                        code = text[0].toupper()
                        if pattern.match(code):
                            yield self.all.addField(name=self._fieldName, value=str(text[0]))
